<?php // $id$
//////////////////////////////////////////////////////////////
//  Reveal & feed-back filtering
// 
//  This filter allows producing automatical insertion of
//  "VENI,VIDI,VICI" tracking detectors using Ajax architecture
//
//////////////////////////////////////////////////////////////

/// This is the filtering function itself.  It accepts the 
/// courseid and the text to be filtered (in HTML form).

/*
* filters img elements that are known as trackers in the resource's body.
* 
* @uses $USER the moodle USER record
* @uses $CFG the moodle overall CFG
* @uses $TRACKERS a variable to cache some scripting text
*/
function ajaxtracking_filter($courseid, $text) {
    global $USER;
    global $CFG;
    global $TRACKERS;
    
    $debug = 0;
    $accumulator = '';
    $course_context = get_context_instance(CONTEXT_COURSE, $courseid);

	// perform filtering only on real content for non teachers
	$hasmarker = preg_match("/alt=\"mark:/", $text);
	if ($hasmarker){
		if (has_capability('mod/coursetracking:teacherview', $course_context)){
		    $CFG->currenttextiscacheable = false;
		    if ($debug) echo "teacher_view";
			if (!isset($TRACKERS->code)){
				$LINES = file ($CFG->dirroot . "/mod/coursetracking/js/objectVisibility.js");
				$TRACKERS->code = implode('', $LINES);

		   	    // loads some extra javascript libraries
    		   	$extratext = "<link type=\"text/css\" rel=\"stylesheet\" src=\"{$CFG->wwwroot}/mod/coursetracking/styles.php\" />\n";
    		   	$extratext = "<script type=\"text/javascript\">{$TRACKERS->code}</script>\n";
    		   	$extratext .= "<style>\n";
    		   	$extratext .= ".init_status { background-color : #DDB6DE }\n";
    		   	$extratext .= ".veni_status { background-color : #F8D3AF }\n";
    		   	$extratext .= ".vidi_status { background-color : #F1F4B9 }\n";
    		   	$extratext .= ".vici_status { background-color : #7ECB88 }\n";
    		   	$extratext .= "</style>\n";
		   	    $accumulator = $extratext . $accumulator;
		    }

            // fixes some tracker image urls that have been damaged by HTMLArea intrusion
            $accumulator = preg_replace("/\\.\\.\\/mod\\/coursetracking/", $CFG->wwwroot . "/mod/coursetracking", $text); 		
            $accumulator = preg_replace("/src=\"mod\\/coursetracking/", "src=\"" . $CFG->wwwroot . "/mod/coursetracking", $text); 		

            // filters out trackers for teacher paperprints
            function removeTrackers($matches){
                $fulltag = $matches[0];
                $trackerid = $matches[2];
                $markerproperties = $matches[3];
                $trackerProperties = coursetracking_fetch_properties($trackerid);
                if ($trackerProperties->teachersseetrackers){
                    list($markerid, $timeout, $delay) = explode(':', $markerproperties);
                    $results = coursetracking_get_counts($trackerid, $markerid);
                    if (isediting()){
                        return $fulltag;
                    } else {
                        return coursetracking_print_results($results, true);
                    }
                }
                return '';
            }

	   	    $accumulator = preg_replace_callback("/<img([^>]*)alt=\"mark:([^:]*):([^\"]*)\"([^>]*)>/sui", 'removeTrackers', $accumulator);
        } else {
	        if ($debug) echo "student_view";
			if (!isset($TRACKERS->code)){
			    $LINES = file ($CFG->dirroot . '/mod/coursetracking/js/objectVisibility.js');
				$TRACKERS->code = implode('', $LINES);
		
		   	    // loads some extra javascript libraries
		   	    $extratext = "<script type=\"text/javascript\">{$TRACKERS->code}</script>\n";
		   	    $extratext .= "<style>\n";
		   	    $extratext .= ".init_status { background-color : #DDB6DE }\n"; 
		   	    $extratext .= ".veni_status { background-color : #F8D3AF }\n";
		   	    $extratext .= ".vidi_status { background-color : #F1F4B9 }\n";
		   	    $extratext .= ".vici_status { background-color : #7ECB88 }\n";
		   	    $extratext .= "</style>\n";
		   	    $text = $extratext . $text;
		   	}

            // get resource id
            $resourceId = required_param('id', PARAM_INT); // get another time resource id (course module)
    	    // passes some data from php to javascript
    	    $extratext = "<script type=\"text/javascript\">\n";
    	    $extratext .= "var current_user = '{$USER->id}';\n";
    	    $extratext .= "var document_id = '{$resourceId}';\n";
    	    $extratext .= "var siteroot = '{$CFG->wwwroot}';\n";
    	    $extratext .= "</script>\n";
    	    $text = $extratext . $text;
	
		    //replaces all special marker divs
	        $remainder = $text;
	        $accumulator = '';
	        // while (preg_match("/(.*?)<div(.*?)id=\"mark:(.*?)\"\s+(.*?)>(.*?)<\/div>(.*)/sui", $remainder, $matches)){
	        // while (preg_match("/(.*?)(?:<img(?:.*?)alt=\"mark:(.*?)\"(.*?)>)|(?:\[MRK:(.*?)\])(.*)/sui", $remainder, $matches)){
	        while (preg_match("/(.*?)<img([^>]*)alt=\"mark:([^\"]*)\"([^>]*)>(.*)/sui", $remainder, $matches)){
	            if ($debug) echo "matched : ".htmlentities($matches[3])."<br/>";
	            $prefix = $matches[1];
	            $id = $matches[3];
	            $postattribs = $matches[4];
	            $postfix = $matches[5];
	            $accumulator .= $prefix;

	            // filter out style extra info. Only width and height are required.
	            // set some defaults. Default should comme from filter configuration parameters
	            $width = $CFG->filter_ajaxtracking_markerdefaultwidth;
	            $height = $CFG->filter_ajaxtracking_markerdefaultheight;
	            $defaultStyle = $CFG->filter_ajaxtracking_markerdefaultstyle;
	            // discard all extra style info and replace with calibrated one
	            if (strpos($matches[2], 'right') !== false){
    	            $style = "style=\"width:{$width};height:{$height};{$defaultStyle};float:right\"";
	            } else {
    	            $style = "style=\"width:{$width};height:{$height};{$defaultStyle}\"";
	            }
	            error_reporting(E_ALL);
	            
	            // check id syntax for replacing entire tag
	            if (preg_match("/([^:]*?):([^:]*?):([^:]*?):([^:]*)$/su", $id, $matches)){
	                $trackerid = $matches[1];
	                $trackerModuleProperties = coursetracking_fetch_properties($trackerid);
	                $canCapture = $trackerModuleProperties->coursetrackingenable == true && coursetracking_check_capture_range($trackerModuleProperties);
	                if($canCapture){
    	                $id = $matches[2];
    	                $delay = $matches[3];
    	                $mode = $matches[4];
    	                $accumulator .= "<a name=\"{$id}\"></a><div id=\"{$id}\" {$style}></div>\n";
    	                $accumulator .= "<script type=\"text/javascript\">\n";
    	                $accumulator .= "trackerIds['{$id}'] = {$trackerid};\n";
    	                $accumulator .= "markerDelais['{$id}'] = {$delay};\n";
    	                $accumulator .= "markerModes['{$id}'] = '{$mode}';\n";
    	                $accumulator .= "loadMarker('{$id}');\n";
    	                $accumulator .= '</script>';
    	            }
	            }
	            elseif (preg_match("/([^:]*?):([^:]*?):([^:]*)$/su", $id, $matches)){
	                $trackerid = $matches[1];
	                $trackerModuleProperties = coursetracking_fetch_properties($trackerid);
	                if($trackerModuleProperties->coursetrackingenable == true && coursetracking_check_capture_range($trackerModuleProperties)){
    	                $id = $matches[2];
    	                $delay = $matches[3];
    	                $accumulator .= "<a name=\"{$id}\"></a><div id=\"{$id}\" {$style}></div>\n";
    	                $accumulator .= "<script type=\"text/javascript\">\n";
    	                $accumulator .= "trackerIds['{$id}'] = {$trackerid};\n";
    	                $accumulator .= "markerDelais['{$id}'] = {$delay};\n";
    	                $accumulator .= "loadMarker('{$id}');\n";
    	                $accumulator .= '</script>';
    	            }
	            }
	            elseif (preg_match("/^([^:]*?):([^:]*)$/su", $id, $matches)){
	                $trackerid = $matches[1];
	                $trackerModuleProperties = coursetracking_fetch_properties($trackerid);
	                if($trackerModuleProperties->coursetrackingenable == true && coursetracking_check_capture_range($trackerModuleProperties)){
    	                $id = $matches[2];
    	                $delay = 'defaultDelay';
    	                $accumulator .= "<a name=\"{$id}\"></a><div id=\"{$id}\" {$style}></div>\n";
    	                $accumulator .= "<script type=\"text/javascript\">\n";
    	                $accumulator .= "trackerIds['{$id}'] = {$trackerid};\n";
    	                $accumulator .= "markerDelais['{$id}'] = {$delay};\n";
    	                $accumulator .= "loadMarker('{$id}');\n";
    	                $accumulator .= '</script>';
    	            }
	            }
	            $remainder = $postfix;
	        }
	        $accumulator .= $remainder;
	      	
		    // writes the poll startup instruction
	        $extratext = "\n<script type=\"text/javascript\">\n";
	        $extratext .= "armPoller();\n";
	        $extratext .= '</script>';
	        $accumulator .= $extratext;
        }
    }

	if ($accumulator == ''){
	    return $text;
	}
    return $accumulator;  // Look for all these words in the text
}

/**
* Gets properties for a particular tracker
* @param int $trackerid
*/
function coursetracking_fetch_properties($trackerid){
    $properties = get_record('coursetracking', 'id', $trackerid);
    return $properties;
}

/**
* Checks if inside the authorised capture time range.
* @param object $trackerProperties a record with coursetracker properties
* @return boolean
*/
function coursetracking_check_capture_range($trackerProperties){
    if ($trackerProperties->capturestartenable == true && time() < $trackerProperties->capturestart) return false;
    if ($trackerProperties->captureendenable == true && time() > $trackerProperties->captureend) return false;
    return true;
}

/**
* get results for a particular marker in a particular tracker.
*/
function coursetracking_get_counts($trackerid, $markerid){
    global $CFG;

    $events = get_records_select_menu('coursetracking_event', " trackerid = {$trackerid} AND markerid = '$markerid' GROUP BY event", '', 'DISTINCT event, COUNT(userid)');

    if (!isset($events['veni']))
        $events['veni'] = 0;
    if (!isset($events['vidi']))
        $events['vidi'] = 0;
    if (!isset($events['vici']))
        $events['vici'] = 0;
    
    $elapsed = get_field_select('coursetracking_event', 'SUM(totaltime)', " trackerid = {$trackerid} AND markerid = '$markerid' AND event = 'vidi' ");
    if ($events['vidi'] > 0){
        $events['meanelapsed'] = $elapsed / $events['vidi'];
    } else {
        $events['meanelapsed'] = 0;
    }

    return $events;
}

/**
* Prints a variant of the tracker widget showing Veni,Vidi,Vici results in the page.
*/
function coursetracking_print_results($results, $return){
    global $CFG;
    
    $langroot = $CFG->dirroot.'/filter/ajaxtracking/lang/';
    
    $venistr = get_string('venicount', 'filter_ajaxtracking', '', $langroot);
    $vidistr = get_string('vidicount', 'filter_ajaxtracking', '', $langroot);
    $vicistr = get_string('vicicount', 'filter_ajaxtracking', '', $langroot);
    $timespentstr = get_string('timeelapsed', 'filter_ajaxtracking', '', $langroot);

    $str = '';
    
    $str .= "<div style=\"float:right\">";    
    $str .= "<table class=\"coursetrackingresults\" style=\"{$CFG->filter_ajaxtracking_markerdefaultstyle}\">";
    $str .= "<tr><td colspan=\"3\" class=\"trackingtitle\">";
    $str .= get_string('coursetracking', 'filter_ajaxtracking', '', $langroot);
    $str .= '</td></tr>';
    $str .= "<tr><td class=\"veniresults\" title=\"$venistr\">";
    $str .= $results['veni'];
    $str .= '</td>';    
    $str .= "<td class=\"vidiresults\" title=\"$vidistr\">";    
    $str .= $results['vidi'];
    $str .= '</td>';    
    $str .= "<td class=\"viciresults\" title=\"$vicistr\">";    
    $str .= $results['vici'];
    $str .= '</td></tr>';
    $str .= "<tr><td colspan=\"3\" class=\"timespentresults\" title=\"$timespentstr\">";
    $str .= $results['meanelapsed'];
    $str .= '</td></tr></table>';    
    $str .= '</div>';    
    
    if ($return) return $str;
    echo $str;
}
?>
